Coin: SoCamera Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoCamera Class Referenceabstract
Node Classes

The SoCamera class is the abstract base class for camera definition nodes. More...

`#include <Inventor/nodes/SoCamera.h>`

Inheritance diagram for SoCamera:

## Public Types
enum | ViewportMapping { CROP_VIEWPORT_FILL_FRAME , CROP_VIEWPORT_LINE_FRAME , CROP_VIEWPORT_NO_FRAME , ADJUST_CAMERA , LEAVE_ALONE }
enum | StereoMode { MONOSCOPIC , LEFT_VIEW , RIGHT_VIEW }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
SbViewVolume | getViewVolume (const SbViewportRegion &vp, SbViewportRegion &resultvp, const SbMatrix &mm=SbMatrix::identity()) const
void | pointAt (const SbVec3f &targetpoint)
void | pointAt (const SbVec3f &targetpoint, const SbVec3f &upvector)
virtual void | scaleHeight (float scalefactor)=0
virtual SbViewVolume | getViewVolume (float useaspectratio=0.0f) const =0
void | viewAll (SoNode *const sceneroot, const SbViewportRegion &vpregion, const float slack=1.0f)
void | viewAll (SoPath *const path, const SbViewportRegion &vpregion, const float slack=1.0f)
SbViewportRegion | getViewportBounds (const SbViewportRegion &region) const
void | setStereoMode (StereoMode mode)
StereoMode | getStereoMode (void) const
void | setStereoAdjustment (float adjustment)
float | getStereoAdjustment (void) const
void | setBalanceAdjustment (float adjustment)
float | getBalanceAdjustment (void) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | viewBoundingBox (const SbBox3f &box, float aspect, float slack)=0
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFEnum | viewportMapping
SoSFVec3f | position
SoSFRotation | orientation
SoSFFloat | aspectRatio
SoSFFloat | nearDistance
SoSFFloat | farDistance
SoSFFloat | focalDistance
Public Attributes inherited from SoBase

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
| SoCamera (void)
virtual | ~SoCamera ()
virtual void | jitter (int numpasses, int curpass, const SbViewportRegion &vpreg, SbVec3f &jitteramount) const
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoCamera class is the abstract base class for camera definition nodes.

To be able to view a scene, one needs to have a camera in the scene graph. A camera node will set up the projection and viewing matrices for rendering of the geometry in the scene.

This node just defines the abstract interface by collecting common fields that all camera type nodes needs. Use the non-abstract camera node subclasses within a scene graph. The ones that are default part of the Coin library are SoPerspectiveCamera and SoOrthographicCamera, which uses the two different projections given by their name.

Note that the viewer components of the GUI glue libraries of Coin (SoXt, SoQt, SoWin, etc) will automatically insert a camera into a scene graph if none has been defined.

It is possible to have more than one camera in a scene graph. One common trick is for instance to use a second camera to display static geometry or overlay geometry (e.g. for head-up displays ("HUD")), as shown by this example code:

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/nodes/SoNodes.h>
int
main(int argc, char ** argv)
{
QWidget * mainwin = SoQt::init(argv[0]);
SoSeparator * root = new SoSeparator;
root->ref();
// Adds a camera and a red cone. The first camera found in the
// scene graph by the SoQtExaminerViewer will be picked up and
// initialized automatically.
root->addChild(new SoPerspectiveCamera);
SoMaterial * material = new SoMaterial;
material->diffuseColor.setValue(1.0, 0.0, 0.0);
root->addChild(material);
root->addChild(new SoCone);
// Set up a second camera for the remaining geometry. This camera
// will not be picked up and influenced by the viewer, so the
// geometry will be kept static.
SoPerspectiveCamera * pcam = new SoPerspectiveCamera;
pcam->position = SbVec3f(0, 0, 5);
pcam->nearDistance = 0.1;
pcam->farDistance = 10;
root->addChild(pcam);
// Adds a green cone to demonstrate static geometry.
SoMaterial * greenmaterial = new SoMaterial;
greenmaterial->diffuseColor.setValue(0, 1.0, 0.0);
root->addChild(greenmaterial);
root->addChild(new SoCone);
SoQtExaminerViewer * viewer = new SoQtExaminerViewer(mainwin);
viewer->setSceneGraph(root);
viewer->show();
SoQt::show(mainwin);
SoQt::mainLoop();
delete viewer;
root->unref();
return 0;
}
SbVec3f
The SbVec3f class is a 3 dimensional vector with floating point coordinates.
Definition SbVec3f.h:51
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoCamera::position
SoSFVec3f position
Definition SoCamera.h:81
SoCamera::farDistance
SoSFFloat farDistance
Definition SoCamera.h:85
SoCamera::nearDistance
SoSFFloat nearDistance
Definition SoCamera.h:84
SoCone
The SoCone class is for rendering cone shapes.
Definition SoCone.h:41
SoGroup::addChild
virtual void addChild(SoNode *node)
Definition SoGroup.cpp:453
SoMaterial
The SoMaterial class is a node type for setting up material values for scene geometry.
Definition SoMaterial.h:44
SoMaterial::diffuseColor
SoMFColor diffuseColor
Definition SoMaterial.h:54
SoPerspectiveCamera
The SoPerspectiveCamera class defines a camera node with perspective rendering.
Definition SoPerspectiveCamera.h:39
SoSeparator
The SoSeparator class is a state-preserving group node.
Definition SoSeparator.h:44

NB: The support for multiple cameras in Coin is limited, and problems with multiple cameras will be considered fixed on a case by case basis.

## Member Enumeration Documentation

## ◆ ViewportMapping

enum SoCamera::ViewportMapping

Enumerates the available possibilities for how the render frame should map the viewport.

## ◆ StereoMode

enum SoCamera::StereoMode

Enumerates the possible stereo modes.

Enumerator
MONOSCOPIC | No stereo.
LEFT_VIEW | Left view.
RIGHT_VIEW | Right view.

## Constructor & Destructor Documentation

## ◆ SoCamera()

SoCamera::SoCamera | ( | void |  | ) |
| protected

Constructor.

## ◆ ~SoCamera()

SoCamera::~SoCamera | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoCamera::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoCamera::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

Reimplemented in SoFrustumCamera, SoOrthographicCamera, SoPerspectiveCamera, and SoReversePerspectiveCamera.

## ◆ getFieldDataPtr()

const SoFieldData ** SoCamera::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoCamera::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

Reimplemented in SoFrustumCamera, SoOrthographicCamera, SoPerspectiveCamera, and SoReversePerspectiveCamera.

## ◆ getViewVolume() [1/2]

SbViewVolume SoCamera::getViewVolume | ( | const SbViewportRegion & | vp,
|  | SbViewportRegion & | resultvp,
|  | const SbMatrix & | mm = SbMatrix::identity() ) const

Convenience method which returns the actual view volume used when rendering, adjusted for the current viewport mapping.

Supply the view's viewport in vp. If the viewport mapping is one of CROP_VIEWPORT_FILL_FRAME, CROP_VIEWPORT_LINE_FRAME or CROP_VIEWPORT_NO_FRAME, resultvp will be modified to contain the resulting viewport.

If you got any transformations in front of the camera, mm should contain this transformation.

Since
  Coin 4.0

## ◆ pointAt() [1/2]

void SoCamera::pointAt | ( | const SbVec3f & | targetpoint | ) |

Reorients the camera so that it points towards targetpoint. The positive Y-axis is used as the up vector of the camera, unless the new camera direction is parallel to this axis, in which case the positive Z-axis will be used instead.

## ◆ pointAt() [2/2]

void SoCamera::pointAt | ( | const SbVec3f & | targetpoint,
|  | const SbVec3f & | upvector )

Reorients the camera so that it points towards targetpoint, using upvector as the camera up vector.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ scaleHeight()

virtual void SoCamera::scaleHeight | ( | float | scalefactor | ) |
| pure virtual

Sets a scalefactor for the height of the camera viewport. What "viewport height" means exactly in this context depends on the camera model. See documentation in subclasses.

Implemented in SoFrustumCamera, SoOrthographicCamera, and SoPerspectiveCamera.

## ◆ getViewVolume() [2/2]

virtual SbViewVolume SoCamera::getViewVolume | ( | float | useaspectratio = 0.0f | ) | const
| pure virtual

Returns total view volume covered by the camera under the current settings.

This view volume is not adjusted to account for viewport mapping. If you want the same view volume as the one used during rendering, you should use getViewVolume(SbViewportRegion & vp, const SbMatrix & mm), or do something like this:

    SbViewVolume vv;
    float aspectratio = myviewport.getViewportAspectRatio();

    switch (camera->viewportMapping.getValue()) {
    case SoCamera::CROP_VIEWPORT_FILL_FRAME:
    case SoCamera::CROP_VIEWPORT_LINE_FRAME:
    case SoCamera::CROP_VIEWPORT_NO_FRAME:
      vv = camera->getViewVolume(0.0f);
      break;
    case SoCamera::ADJUST_CAMERA:
      vv = camera->getViewVolume(aspectratio);
      if (aspectratio < 1.0f) vv.scale(1.0f / aspectratio);
      break;
    case SoCamera::LEAVE_ALONE:
      vv = camera->getViewVolume(0.0f);
      break;
    default:
      assert(0 && "unknown viewport mapping");
      break;
    }

Also, for the CROPPED viewport mappings, the viewport might be changed if the viewport aspect ratio is not equal to the camera aspect ratio. See the SoCamera::getView() source-code (private method) to see how this is done.

Implemented in SoFrustumCamera, SoOrthographicCamera, and SoPerspectiveCamera.

## ◆ viewAll() [1/2]

void SoCamera::viewAll | ( | SoNode *const | sceneroot,
|  | const SbViewportRegion & | vpregion,
|  | const float | slack = 1.0f )

Position the camera so that all geometry of the scene from sceneroot is contained in the view volume of the camera, while keeping the camera orientation constant.

Finds the bounding box of the scene and calls SoCamera::viewBoundingBox(). A bounding sphere will be calculated from the scene bounding box, so the camera will "view all" even when the scene is rotated, in any way.

The slack argument gives a multiplication factor to the distance the camera is supposed to move out from the sceneroot mid-point.

A value less than 1.0 for the slack argument will therefore cause the camera to come closer to the scene, a value of 1.0 will position the camera as exactly outside the scene bounding sphere, and a value larger than 1.0 will give "extra slack" versus the scene bounding sphere.

## ◆ viewAll() [2/2]

void SoCamera::viewAll | ( | SoPath *const | path,
|  | const SbViewportRegion & | vpregion,
|  | const float | slack = 1.0f )

Position the camera so all geometry of the scene in path is contained in the view volume of the camera.

Finds the bounding box of the scene and calls SoCamera::viewBoundingBox().

## ◆ getViewportBounds()

SbViewportRegion SoCamera::getViewportBounds | ( | const SbViewportRegion & | region | ) | const

Based in the SoCamera::viewportMapping setting, convert the values of region to the viewport region we will actually render into.

## ◆ setStereoMode()

void SoCamera::setStereoMode | ( | StereoMode | mode | ) |

Sets the stereo mode.

## ◆ getStereoMode()

SoCamera::StereoMode SoCamera::getStereoMode | ( | void |  | ) | const

Returns the stereo mode.

## ◆ setStereoAdjustment()

void SoCamera::setStereoAdjustment | ( | float | adjustment | ) |

Sets the stereo adjustment. This is the distance between the left and right "eye" when doing stereo rendering.

When doing stereo rendering, Coin will render two views, one for the left eye, and one for the right eye. The stereo adjustment is, a bit simplified, how much the camera is translated along the local X-axis between the left and the right view.

The default distance is 0.1, which is chosen since it is the approximate distance between the human eyes.

To create a nice looking and visible stereo effect, the application programmer will often have to adjust this value. If all you want to do is examine simple standalone 3D objects, it is possible to calculate a stereo offset based on the bounding box of the 3D model (or scale the model down to an appropriate size).

However, if you have a large scene, where you want to fly around in the scene, and see stereo on different objects as you approach them, you can't calculate the stereo offset based on the bounding box of the scene, but rather use a stereo offset based on the scale of the individual objects/details you want to examine.

Please note that it is important to set a sensible focal distance when doing stereo rendering. See setBalanceAdjustment() for information about how the focal distance affects the stereo rendering.

See also
  setBalanceAdjustment()

## ◆ getStereoAdjustment()

float SoCamera::getStereoAdjustment | ( | void |  | ) | const

Returns the stereo adjustment.

See also
  setStereoAdjustment()

## ◆ setBalanceAdjustment()

void SoCamera::setBalanceAdjustment | ( | float | adjustment | ) |

Sets the stereo balance adjustment. This is a factor that enables you to move the zero parallax plane. Geometry in front of the zero parallax plane will appear to be in front of the screen.

The balance adjustment is multiplied with the focal distance to find the zero parallax plane. The default value is 1.0, and the zero parallax plane is then at the focal point.

See also
  SoCamera::focalDistance

## ◆ getBalanceAdjustment()

float SoCamera::getBalanceAdjustment | ( | void |  | ) | const

Returns the stereo balance adjustment.

See also
  setBalanceAdjustment()

## ◆ doAction()

void SoCamera::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ callback()

void SoCamera::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## ◆ GLRender()

void SoCamera::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## ◆ audioRender()

void SoCamera::audioRender | ( | SoAudioRenderAction * | action | ) |
| virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoNode.

## ◆ getBoundingBox()

void SoCamera::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

## ◆ getMatrix()

void SoCamera::getMatrix | ( | SoGetMatrixAction * | action | ) |
| virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

## ◆ handleEvent()

void SoCamera::handleEvent | ( | SoHandleEventAction * | action | ) |
| virtual

Picking actions can be triggered during handle event action traversal, and to do picking we need to know the camera state.

See also
  SoCamera::rayPick()

Reimplemented from SoNode.

## ◆ rayPick()

void SoCamera::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

## ◆ getPrimitiveCount()

void SoCamera::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

## ◆ viewBoundingBox()

virtual void SoCamera::viewBoundingBox | ( | const SbBox3f & | box,
|  | float | aspect,
|  | float | slack )
| pure virtual

Convenience method for setting up the camera definition to cover the given bounding box with the given aspect ratio. Multiplies the exact dimensions with a slack factor to have some space between the rendered model and the borders of the rendering area.

If you define your own camera node class, be aware that this method should not set the orientation field of the camera, only the position, focal distance and near and far clipping planes.

Implemented in SoFrustumCamera, SoOrthographicCamera, and SoPerspectiveCamera.

## ◆ jitter()

void SoCamera::jitter | ( | int | numpasses,
|  | int | curpass,
|  | const SbViewportRegion & | vpreg,
|  | SbVec3f & | jitteramount ) const
| protectedvirtual

"Jitter" the camera according to the current rendering pass (curpass), to get an antialiased rendering of the scene when doing multipass rendering.

## Member Data Documentation

## ◆ viewportMapping

SoSFEnum SoCamera::viewportMapping

Set up how the render frame should map the viewport. The default is SoCamera::ADJUST_CAMERA.

## ◆ position

SoSFVec3f SoCamera::position

Camera position. Defaults to <0,0,1>.

## ◆ orientation

SoSFRotation SoCamera::orientation

Camera orientation specified as a rotation value from the default orientation where the camera is pointing along the negative Z-axis, with "up" along the positive Y-axis.

E.g., to rotate the camera to point along the X-axis:

mycamera->orientation.setValue(SbRotation(SbVec3f(0, 1, 0), M_PI / 2.0f));
SbRotation
The SbRotation class represents a rotation in 3D space.
Definition SbRotation.h:44

For queries, e.g. to get the current "up" and "look at" vectors of the camera:

SbRotation camrot = mycamera->orientation.getValue();
SbVec3f upvec(0, 1, 0); // init to default up vector
camrot.multVec(upvec, upvec);
SbVec3f lookat(0, 0, -1); // init to default view direction vector
camrot.multVec(lookat, lookat);
SbRotation::multVec
void multVec(const SbVec3f &src, SbVec3f &dst) const
Definition SbRotation.cpp:621
SbRotation::getValue
const float * getValue(void) const
Definition SbRotation.cpp:197

## ◆ aspectRatio

SoSFFloat SoCamera::aspectRatio

Aspect ratio for the camera (i.e. width / height). Defaults to 1.0.

## ◆ nearDistance

SoSFFloat SoCamera::nearDistance

Distance from camera position to the near clipping plane in the camera's view volume.

Default value is 1.0. Value must be larger than 0.0, or it will not be possible to construct a valid viewing volume (for perspective rendering, at least).

If you use one of the viewer components from the So[Xt|Qt|Win|Gtk] GUI libraries provided Kongsberg Oil & Gas Technologies, they will automatically update this value for the scene camera according to the scene bounding box. Ditto for the far clipping plane.

See also
  SoCamera::farDistance

## ◆ farDistance

SoSFFloat SoCamera::farDistance

Distance from camera position to the far clipping plane in the camera's view volume.

Default value is 10.0. Must be larger than the SoCamera::nearDistance value, or it will not be possible to construct a valid viewing volume.

Note that the range [nearDistance, farDistance] decides the dynamic range of the z-buffer in the underlying polygon-rendering rasterizer. What this means is that if the near and far clipping planes of the camera are wide apart, the possibility of visual artifacts will increase. The artifacts will manifest themselves in the form of flickering of primitives close in depth.

It is therefore a good idea to keep the near and far clipping planes of your camera(s) as closely fitted around the geometry of the scene graph as possible.

See also
  SoCamera::nearDistance, SoPolygonOffset

## ◆ focalDistance

SoSFFloat SoCamera::focalDistance

Distance from camera position to center of scene.

The documentation for this class was generated from the following files:

- SoCamera.h
- SoCamera.cpp